#!/bin/bash
# NdisWrapper configuration script
# (C) Martin Oehler 2004

PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin:/usr/local/bin"
export PATH

# Get root
[ "`id -u`" != "0" ] && exec sudo "$0" "$@"
unset SUDO_COMMAND

XDIALOG_HIGH_DIALOG_COMPAT=1
export XDIALOG_HIGH_DIALOG_COMPAT

XDIALOG_FORCE_AUTOSIZE=1
export XDIALOG_FORCE_AUTOSIZE

TMP="/tmp/ndiswrapper.$$"

DIALOG="dialog"
[ -n "$DISPLAY" ] && [ -x /usr/bin/Xdialog ] && DIALOG="Xdialog"

trap bailout 1 2 3 15

bailout(){
rm -f "$TMP"
exit $1
}

BACKTITLE="KNOPPIX NDISWRAPPER TOOL"

# at first we show the usual disclaimer that the usage of this
# script could simply destroy everything

# dialog knows no --center
if [ "$DIALOG" = "dialog" ]; then
  $DIALOG --backtitle "$BACKTITLE" --title "DISCLAIMER" --msgbox "This is the configuration tool for the ndiswrapper utilities. \n
Be aware that loading a windows driver file for your wlan \n
card using this tool could freeze your system. \n 
\n
You need matching driver.inf and driver.sys files residing on \n
a mounted data medium. After the windows drivers have been \n
successfully loaded via the ndiswrapper, you have to configure \n
your wlan settings via iwconfig. Future releases of this script \n
will include this. \n
\n
Please send your feedback to <oehler@knopper.net>" 16 75;
else
  $DIALOG --center --backtitle "$BACKTITLE" --title "DISCLAIMER" --msgbox "This is the configuration tool for the ndiswrapper utilities. \n
Be aware that loading a windows driver file for your \n
wlan card using this tool could freeze your system. \n 
\n
You need matching driver.inf and driver.sys files residing on \n
a mounted data medium. After the windows drivers have been \n
successfully loaded via the ndiswrapper, you have to configure \n
your wlan settings via iwconfig. Future releases of this script \n
will include this. \n
\n
Please send your feedback to \n
<oehler@knopper.net>" 12 75;
fi

$DIALOG --backtitle "$BACKTITLE" --title "DRIVER SELECTION (*.inf)" --fselect "/home/knoppix" 12 75 2>"$TMP"; read DRIVER_PATH <"$TMP"; rm -f "$TMP";

test -x "/usr/sbin/ndiswrapper" || { echo "NdisWrapper not found, exiting." >&2; exit 1; }
test -x "/sbin/modprobe" || { echo "modprobe not found, exiting." >&2; exit 1; }
test -e $DRIVER_PATH || { echo "$DRIVER_PATH does not exist, exiting." >&2; exit 1; }
case "$DRIVER_PATH" in 
  *\.inf*) NUM=`grep -c "sys" "$DRIVER_PATH"`
           if [ "$NUM" -lt 1 ]; then 
             echo "No valid inf-file, exiting." >&2; exit 1;
	   fi;;
  *) echo "No *.inf file, exiting." >&2; exit 1; 
esac

# how much lines are in /proc/net/wireless 
LINES1=`cat /proc/net/wireless | wc -l`

ndiswrapper -i "$DRIVER_PATH"
modprobe ndiswrapper
ndiswrapper -m

# have we got a new device?
LINES2=`cat /proc/net/wireless | wc -l`

if [ "$LINES2" -gt "$LINES1" ]; then
  $DIALOG --backtitle "$BACKTITLE" --title "RESULT" --msgbox "The ndiswrapper module has been loaded. You may configure your wlan card with iwconfig now." 12 75 2>"$TMP"; [ "$?" != "0" ] && return 1; rm -f "$TMP";
else
  $DIALOG --backtitle "$BACKTITLE" --title "RESULT" --msgbox "The ndiswrapper module has been loaded but there is no new device. Perhaps NdisWrapper is not working with your driver file." 12 75 2>"$TMP"; [ "$?" != "0" ] && return 1; rm -f "$TMP";
fi
